/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package ChatProgramm.model;

import ChatProgramm.util.OhmLogger;
import ChatProgramm.view.ChatView;
import ChatProgramm.view.GrafikView;
import java.util.concurrent.Flow;
import java.util.concurrent.Flow.Subscriber;
import java.util.logging.Logger;

/**
 *
 * @author ahren
 */
public class ReceiveAdapter implements Subscriber<Figur> {
    
    private static Logger lg = OhmLogger.getLogger();

    private ChatView view;
    private GrafikModel model;
    private GrafikView gView;
    private Flow.Subscription subscription;

    public ReceiveAdapter(ChatView view, GrafikModel model, GrafikView gView) {
        this.view = view;
        this.model = model;
        this.gView = gView;
        
       
    }

    @Override
    public void onSubscribe(Flow.Subscription subscription) {
        this.subscription = subscription;
        this.subscription.request(1);
    }

    public void onNext(Figur item) {
        
        lg.info("Figur wurde dem Grafikmodel hinzugefügt");
        model.addFigur(item);
        gView.drawPoint();
        // evtl muss die Figur aber zuerst serialisiert werden
        //view.getTxtChat().append(item.getNachricht());
        this.subscription.request(1);
    }

    @Override
    public void onError(Throwable throwable) {
    }

    @Override
    public void onComplete(){
    }

}
